From 42e39640f24ee15b5596e7cbb6831785883ca627 Mon Sep 17 00:00:00 2001
From: Andres Freund <andres@anarazel.de>
Date: Tue, 20 Feb 2018 14:40:23 -0800
Subject: [PATCH] tupleslot-rewrite

---
 src/backend/access/common/heaptuple.c          |  268 +-----
 src/backend/access/common/printsimple.c        |    6 +-
 src/backend/access/common/printtup.c           |   24 +-
 src/backend/catalog/index.c                    |   18 +-
 src/backend/catalog/indexing.c                 |    3 +-
 src/backend/catalog/partition.c                |    2 +-
 src/backend/commands/analyze.c                 |    3 +-
 src/backend/commands/constraint.c              |    3 +-
 src/backend/commands/copy.c                    |    8 +-
 src/backend/commands/createas.c                |    2 +-
 src/backend/commands/subscriptioncmds.c        |    2 +-
 src/backend/commands/tablecmds.c               |    6 +-
 src/backend/commands/trigger.c                 |   22 +-
 src/backend/executor/execCurrent.c             |   19 +-
 src/backend/executor/execExpr.c                |    7 +-
 src/backend/executor/execExprInterp.c          |  102 +--
 src/backend/executor/execGrouping.c            |    3 +-
 src/backend/executor/execIndexing.c            |    3 +-
 src/backend/executor/execJunk.c                |   12 +-
 src/backend/executor/execMain.c                |    6 +-
 src/backend/executor/execPartition.c           |    7 +-
 src/backend/executor/execReplication.c         |   30 +-
 src/backend/executor/execSRF.c                 |    4 +-
 src/backend/executor/execScan.c                |    4 +-
 src/backend/executor/execTuples.c              | 1048 ++++++++++++++++--------
 src/backend/executor/execUtils.c               |    6 +-
 src/backend/executor/functions.c               |    5 +-
 src/backend/executor/nodeAgg.c                 |   39 +-
 src/backend/executor/nodeAppend.c              |    2 +-
 src/backend/executor/nodeBitmapHeapscan.c      |    6 +-
 src/backend/executor/nodeCtescan.c             |    5 +-
 src/backend/executor/nodeCustom.c              |    6 +-
 src/backend/executor/nodeForeignscan.c         |    9 +-
 src/backend/executor/nodeFunctionscan.c        |   21 +-
 src/backend/executor/nodeGather.c              |    5 +-
 src/backend/executor/nodeGatherMerge.c         |    5 +-
 src/backend/executor/nodeGroup.c               |    5 +-
 src/backend/executor/nodeHash.c                |    2 +-
 src/backend/executor/nodeHashjoin.c            |   13 +-
 src/backend/executor/nodeIndexonlyscan.c       |   12 +-
 src/backend/executor/nodeIndexscan.c           |    5 +-
 src/backend/executor/nodeLimit.c               |    3 +-
 src/backend/executor/nodeLockRows.c            |    2 +-
 src/backend/executor/nodeMaterial.c            |    4 +-
 src/backend/executor/nodeMergeAppend.c         |    3 +-
 src/backend/executor/nodeMergejoin.c           |   13 +-
 src/backend/executor/nodeModifyTable.c         |   27 +-
 src/backend/executor/nodeNamedtuplestorescan.c |    5 +-
 src/backend/executor/nodeNestloop.c            |    5 +-
 src/backend/executor/nodeProjectSet.c          |    6 +-
 src/backend/executor/nodeRecursiveunion.c      |    2 +-
 src/backend/executor/nodeResult.c              |    2 +-
 src/backend/executor/nodeSamplescan.c          |    6 +-
 src/backend/executor/nodeSeqscan.c             |    5 +-
 src/backend/executor/nodeSetOp.c               |    2 +-
 src/backend/executor/nodeSort.c                |    4 +-
 src/backend/executor/nodeSubplan.c             |   12 +-
 src/backend/executor/nodeSubqueryscan.c        |    6 +-
 src/backend/executor/nodeTableFuncscan.c       |   16 +-
 src/backend/executor/nodeTidscan.c             |    5 +-
 src/backend/executor/nodeUnique.c              |    2 +-
 src/backend/executor/nodeValuesscan.c          |   12 +-
 src/backend/executor/nodeWindowAgg.c           |   24 +-
 src/backend/executor/nodeWorktablescan.c       |    4 +-
 src/backend/executor/tstoreReceiver.c          |    8 +-
 src/backend/nodes/print.c                      |    2 +-
 src/backend/replication/logical/tablesync.c    |    4 +-
 src/backend/replication/logical/worker.c       |   60 +-
 src/backend/tcop/pquery.c                      |    2 +-
 src/backend/utils/adt/orderedsetaggs.c         |   34 +-
 src/backend/utils/adt/selfuncs.c               |    3 +-
 src/backend/utils/sort/tuplesort.c             |    2 +-
 src/include/access/htup_details.h              |    5 +
 src/include/executor/executor.h                |   16 +-
 src/include/executor/tuptable.h                |  204 ++++-
 src/include/nodes/execnodes.h                  |    3 +
 76 files changed, 1306 insertions(+), 965 deletions(-)

diff --git a/src/backend/access/common/heaptuple.c b/src/backend/access/common/heaptuple.c
index 0a13251067f..5ef9ea5c483 100644
--- a/src/backend/access/common/heaptuple.c
+++ b/src/backend/access/common/heaptuple.c
@@ -1032,18 +1032,17 @@ heap_deform_tuple(HeapTuple tuple, TupleDesc tupleDesc,
  *		re-computing information about previously extracted attributes.
  *		slot->tts_nvalid is the number of attributes already extracted.
  */
-static void
-slot_deform_tuple(TupleTableSlot *slot, int natts)
+void
+slot_deform_tuple(TupleTableSlot *slot, HeapTuple tuple, uint32 *offp, int natts)
 {
-	HeapTuple	tuple = slot->tts_tuple;
-	TupleDesc	tupleDesc = slot->tts_tupleDescriptor;
-	Datum	   *values = slot->tts_values;
-	bool	   *isnull = slot->tts_isnull;
+	TupleDesc	tupleDesc = slot->tupleDescriptor;
+	Datum	   *values = slot->values;
+	bool	   *isnull = slot->nulls;
 	HeapTupleHeader tup = tuple->t_data;
 	bool		hasnulls = HeapTupleHasNulls(tuple);
 	int			attnum;
 	char	   *tp;				/* ptr to tuple data */
-	long		off;			/* offset in tuple data */
+	uint32		off;			/* offset in tuple data */
 	bits8	   *bp = tup->t_bits;	/* ptr to null bitmap in tuple */
 	bool		slow;			/* can we use/set attcacheoff? */
 
@@ -1051,7 +1050,7 @@ slot_deform_tuple(TupleTableSlot *slot, int natts)
 	 * Check whether the first call for this tuple, and initialize or restore
 	 * loop state.
 	 */
-	attnum = slot->tts_nvalid;
+	attnum = slot->nvalid;
 	if (attnum == 0)
 	{
 		/* Start from the first attribute */
@@ -1061,8 +1060,8 @@ slot_deform_tuple(TupleTableSlot *slot, int natts)
 	else
 	{
 		/* Restore state from previous execution */
-		off = slot->tts_off;
-		slow = slot->tts_slow;
+		off = *offp;
+		slow = (slot->flags & TTS_SLOW) != 0;
 	}
 
 	tp = (char *) tup + tup->t_hoff;
@@ -1121,249 +1120,12 @@ slot_deform_tuple(TupleTableSlot *slot, int natts)
 	/*
 	 * Save state for next execution
 	 */
-	slot->tts_nvalid = attnum;
-	slot->tts_off = off;
-	slot->tts_slow = slow;
-}
-
-/*
- * slot_getattr
- *		This function fetches an attribute of the slot's current tuple.
- *		It is functionally equivalent to heap_getattr, but fetches of
- *		multiple attributes of the same tuple will be optimized better,
- *		because we avoid O(N^2) behavior from multiple calls of
- *		nocachegetattr(), even when attcacheoff isn't usable.
- *
- *		A difference from raw heap_getattr is that attnums beyond the
- *		slot's tupdesc's last attribute will be considered NULL even
- *		when the physical tuple is longer than the tupdesc.
- */
-Datum
-slot_getattr(TupleTableSlot *slot, int attnum, bool *isnull)
-{
-	HeapTuple	tuple = slot->tts_tuple;
-	TupleDesc	tupleDesc = slot->tts_tupleDescriptor;
-	HeapTupleHeader tup;
-
-	/*
-	 * system attributes are handled by heap_getsysattr
-	 */
-	if (attnum <= 0)
-	{
-		if (tuple == NULL)		/* internal error */
-			elog(ERROR, "cannot extract system attribute from virtual tuple");
-		if (tuple == &(slot->tts_minhdr))	/* internal error */
-			elog(ERROR, "cannot extract system attribute from minimal tuple");
-		return heap_getsysattr(tuple, attnum, tupleDesc, isnull);
-	}
-
-	/*
-	 * fast path if desired attribute already cached
-	 */
-	if (attnum <= slot->tts_nvalid)
-	{
-		*isnull = slot->tts_isnull[attnum - 1];
-		return slot->tts_values[attnum - 1];
-	}
-
-	/*
-	 * return NULL if attnum is out of range according to the tupdesc
-	 */
-	if (attnum > tupleDesc->natts)
-	{
-		*isnull = true;
-		return (Datum) 0;
-	}
-
-	/*
-	 * otherwise we had better have a physical tuple (tts_nvalid should equal
-	 * natts in all virtual-tuple cases)
-	 */
-	if (tuple == NULL)			/* internal error */
-		elog(ERROR, "cannot extract attribute from empty tuple slot");
-
-	/*
-	 * return NULL if attnum is out of range according to the tuple
-	 *
-	 * (We have to check this separately because of various inheritance and
-	 * table-alteration scenarios: the tuple could be either longer or shorter
-	 * than the tupdesc.)
-	 */
-	tup = tuple->t_data;
-	if (attnum > HeapTupleHeaderGetNatts(tup))
-	{
-		*isnull = true;
-		return (Datum) 0;
-	}
-
-	/*
-	 * check if target attribute is null: no point in groveling through tuple
-	 */
-	if (HeapTupleHasNulls(tuple) && att_isnull(attnum - 1, tup->t_bits))
-	{
-		*isnull = true;
-		return (Datum) 0;
-	}
-
-	/*
-	 * If the attribute's column has been dropped, we force a NULL result.
-	 * This case should not happen in normal use, but it could happen if we
-	 * are executing a plan cached before the column was dropped.
-	 */
-	if (TupleDescAttr(tupleDesc, attnum - 1)->attisdropped)
-	{
-		*isnull = true;
-		return (Datum) 0;
-	}
-
-	/*
-	 * Extract the attribute, along with any preceding attributes.
-	 */
-	slot_deform_tuple(slot, attnum);
-
-	/*
-	 * The result is acquired from tts_values array.
-	 */
-	*isnull = slot->tts_isnull[attnum - 1];
-	return slot->tts_values[attnum - 1];
-}
-
-/*
- * slot_getallattrs
- *		This function forces all the entries of the slot's Datum/isnull
- *		arrays to be valid.  The caller may then extract data directly
- *		from those arrays instead of using slot_getattr.
- */
-void
-slot_getallattrs(TupleTableSlot *slot)
-{
-	int			tdesc_natts = slot->tts_tupleDescriptor->natts;
-	int			attnum;
-	HeapTuple	tuple;
-
-	/* Quick out if we have 'em all already */
-	if (slot->tts_nvalid == tdesc_natts)
-		return;
-
-	/*
-	 * otherwise we had better have a physical tuple (tts_nvalid should equal
-	 * natts in all virtual-tuple cases)
-	 */
-	tuple = slot->tts_tuple;
-	if (tuple == NULL)			/* internal error */
-		elog(ERROR, "cannot extract attribute from empty tuple slot");
-
-	/*
-	 * load up any slots available from physical tuple
-	 */
-	attnum = HeapTupleHeaderGetNatts(tuple->t_data);
-	attnum = Min(attnum, tdesc_natts);
-
-	slot_deform_tuple(slot, attnum);
-
-	/*
-	 * If tuple doesn't have all the atts indicated by tupleDesc, read the
-	 * rest as null
-	 */
-	for (; attnum < tdesc_natts; attnum++)
-	{
-		slot->tts_values[attnum] = (Datum) 0;
-		slot->tts_isnull[attnum] = true;
-	}
-	slot->tts_nvalid = tdesc_natts;
-}
-
-/*
- * slot_getsomeattrs
- *		This function forces the entries of the slot's Datum/isnull
- *		arrays to be valid at least up through the attnum'th entry.
- */
-void
-slot_getsomeattrs(TupleTableSlot *slot, int attnum)
-{
-	HeapTuple	tuple;
-	int			attno;
-
-	/* Quick out if we have 'em all already */
-	if (slot->tts_nvalid >= attnum)
-		return;
-
-	/* Check for caller error */
-	if (attnum <= 0 || attnum > slot->tts_tupleDescriptor->natts)
-		elog(ERROR, "invalid attribute number %d", attnum);
-
-	/*
-	 * otherwise we had better have a physical tuple (tts_nvalid should equal
-	 * natts in all virtual-tuple cases)
-	 */
-	tuple = slot->tts_tuple;
-	if (tuple == NULL)			/* internal error */
-		elog(ERROR, "cannot extract attribute from empty tuple slot");
-
-	/*
-	 * load up any slots available from physical tuple
-	 */
-	attno = HeapTupleHeaderGetNatts(tuple->t_data);
-	attno = Min(attno, attnum);
-
-	slot_deform_tuple(slot, attno);
-
-	/*
-	 * If tuple doesn't have all the atts indicated by tupleDesc, read the
-	 * rest as null
-	 */
-	for (; attno < attnum; attno++)
-	{
-		slot->tts_values[attno] = (Datum) 0;
-		slot->tts_isnull[attno] = true;
-	}
-	slot->tts_nvalid = attnum;
-}
-
-/*
- * slot_attisnull
- *		Detect whether an attribute of the slot is null, without
- *		actually fetching it.
- */
-bool
-slot_attisnull(TupleTableSlot *slot, int attnum)
-{
-	HeapTuple	tuple = slot->tts_tuple;
-	TupleDesc	tupleDesc = slot->tts_tupleDescriptor;
-
-	/*
-	 * system attributes are handled by heap_attisnull
-	 */
-	if (attnum <= 0)
-	{
-		if (tuple == NULL)		/* internal error */
-			elog(ERROR, "cannot extract system attribute from virtual tuple");
-		if (tuple == &(slot->tts_minhdr))	/* internal error */
-			elog(ERROR, "cannot extract system attribute from minimal tuple");
-		return heap_attisnull(tuple, attnum);
-	}
-
-	/*
-	 * fast path if desired attribute already cached
-	 */
-	if (attnum <= slot->tts_nvalid)
-		return slot->tts_isnull[attnum - 1];
-
-	/*
-	 * return NULL if attnum is out of range according to the tupdesc
-	 */
-	if (attnum > tupleDesc->natts)
-		return true;
-
-	/*
-	 * otherwise we had better have a physical tuple (tts_nvalid should equal
-	 * natts in all virtual-tuple cases)
-	 */
-	if (tuple == NULL)			/* internal error */
-		elog(ERROR, "cannot extract attribute from empty tuple slot");
-
-	/* and let the tuple tell it */
-	return heap_attisnull(tuple, attnum);
+	slot->nvalid = attnum;
+	*offp = off;
+	if (slow)
+		slot->flags |= TTS_SLOW;
+	else
+		slot->flags &= ~TTS_SLOW;
 }
 
 /*
diff --git a/src/backend/access/common/printsimple.c b/src/backend/access/common/printsimple.c
index 3c4d2277125..b3eb4f96757 100644
--- a/src/backend/access/common/printsimple.c
+++ b/src/backend/access/common/printsimple.c
@@ -58,7 +58,7 @@ printsimple_startup(DestReceiver *self, int operation, TupleDesc tupdesc)
 bool
 printsimple(TupleTableSlot *slot, DestReceiver *self)
 {
-	TupleDesc	tupdesc = slot->tts_tupleDescriptor;
+	TupleDesc	tupdesc = slot->tupleDescriptor;
 	StringInfoData buf;
 	int			i;
 
@@ -74,13 +74,13 @@ printsimple(TupleTableSlot *slot, DestReceiver *self)
 		Form_pg_attribute attr = TupleDescAttr(tupdesc, i);
 		Datum		value;
 
-		if (slot->tts_isnull[i])
+		if (slot->nulls[i])
 		{
 			pq_sendint32(&buf, -1);
 			continue;
 		}
 
-		value = slot->tts_values[i];
+		value = slot->values[i];
 
 		/*
 		 * We can't call the regular type output functions here because we
diff --git a/src/backend/access/common/printtup.c b/src/backend/access/common/printtup.c
index a1d44157044..795b3f19a07 100644
--- a/src/backend/access/common/printtup.c
+++ b/src/backend/access/common/printtup.c
@@ -373,7 +373,7 @@ printtup_prepare_info(DR_printtup *myState, TupleDesc typeinfo, int numAttrs)
 static bool
 printtup(TupleTableSlot *slot, DestReceiver *self)
 {
-	TupleDesc	typeinfo = slot->tts_tupleDescriptor;
+	TupleDesc	typeinfo = slot->tupleDescriptor;
 	DR_printtup *myState = (DR_printtup *) self;
 	MemoryContext oldcontext;
 	StringInfo	buf = &myState->buf;
@@ -403,9 +403,9 @@ printtup(TupleTableSlot *slot, DestReceiver *self)
 	for (i = 0; i < natts; ++i)
 	{
 		PrinttupAttrInfo *thisState = myState->myinfo + i;
-		Datum		attr = slot->tts_values[i];
+		Datum		attr = slot->values[i];
 
-		if (slot->tts_isnull[i])
+		if (slot->nulls[i])
 		{
 			pq_sendint32(buf, -1);
 			continue;
@@ -458,7 +458,7 @@ printtup(TupleTableSlot *slot, DestReceiver *self)
 static bool
 printtup_20(TupleTableSlot *slot, DestReceiver *self)
 {
-	TupleDesc	typeinfo = slot->tts_tupleDescriptor;
+	TupleDesc	typeinfo = slot->tupleDescriptor;
 	DR_printtup *myState = (DR_printtup *) self;
 	MemoryContext oldcontext;
 	StringInfo	buf = &myState->buf;
@@ -489,7 +489,7 @@ printtup_20(TupleTableSlot *slot, DestReceiver *self)
 	k = 1 << 7;
 	for (i = 0; i < natts; ++i)
 	{
-		if (!slot->tts_isnull[i])
+		if (!slot->nulls[i])
 			j |= k;				/* set bit if not null */
 		k >>= 1;
 		if (k == 0)				/* end of byte? */
@@ -508,10 +508,10 @@ printtup_20(TupleTableSlot *slot, DestReceiver *self)
 	for (i = 0; i < natts; ++i)
 	{
 		PrinttupAttrInfo *thisState = myState->myinfo + i;
-		Datum		attr = slot->tts_values[i];
+		Datum		attr = slot->values[i];
 		char	   *outputstr;
 
-		if (slot->tts_isnull[i])
+		if (slot->nulls[i])
 			continue;
 
 		Assert(thisState->format == 0);
@@ -605,7 +605,7 @@ debugStartup(DestReceiver *self, int operation, TupleDesc typeinfo)
 bool
 debugtup(TupleTableSlot *slot, DestReceiver *self)
 {
-	TupleDesc	typeinfo = slot->tts_tupleDescriptor;
+	TupleDesc	typeinfo = slot->tupleDescriptor;
 	int			natts = typeinfo->natts;
 	int			i;
 	Datum		attr;
@@ -643,7 +643,7 @@ debugtup(TupleTableSlot *slot, DestReceiver *self)
 static bool
 printtup_internal_20(TupleTableSlot *slot, DestReceiver *self)
 {
-	TupleDesc	typeinfo = slot->tts_tupleDescriptor;
+	TupleDesc	typeinfo = slot->tupleDescriptor;
 	DR_printtup *myState = (DR_printtup *) self;
 	MemoryContext oldcontext;
 	StringInfo	buf = &myState->buf;
@@ -674,7 +674,7 @@ printtup_internal_20(TupleTableSlot *slot, DestReceiver *self)
 	k = 1 << 7;
 	for (i = 0; i < natts; ++i)
 	{
-		if (!slot->tts_isnull[i])
+		if (!slot->nulls[i])
 			j |= k;				/* set bit if not null */
 		k >>= 1;
 		if (k == 0)				/* end of byte? */
@@ -693,10 +693,10 @@ printtup_internal_20(TupleTableSlot *slot, DestReceiver *self)
 	for (i = 0; i < natts; ++i)
 	{
 		PrinttupAttrInfo *thisState = myState->myinfo + i;
-		Datum		attr = slot->tts_values[i];
+		Datum		attr = slot->values[i];
 		bytea	   *outputbytes;
 
-		if (slot->tts_isnull[i])
+		if (slot->nulls[i])
 			continue;
 
 		Assert(thisState->format == 1);
diff --git a/src/backend/catalog/index.c b/src/backend/catalog/index.c
index f2cb6d7fb81..8fa19526214 100644
--- a/src/backend/catalog/index.c
+++ b/src/backend/catalog/index.c
@@ -1964,7 +1964,14 @@ FormIndexDatum(IndexInfo *indexInfo,
 		Datum		iDatum;
 		bool		isNull;
 
-		if (keycol != 0)
+		if (keycol < 0)
+		{
+			iDatum = heap_getsysattr(((HeapTupleTableSlot *) slot)->tuple,
+									 keycol,
+									 slot->tupleDescriptor,
+									 &isNull);
+		}
+		else if (keycol != 0)
 		{
 			/*
 			 * Plain index column; get the value we need directly from the
@@ -2445,7 +2452,8 @@ IndexBuildHeapRangeScan(Relation heapRelation,
 	 */
 	estate = CreateExecutorState();
 	econtext = GetPerTupleExprContext(estate);
-	slot = MakeSingleTupleTableSlot(RelationGetDescr(heapRelation));
+	slot = MakeSingleTupleTableSlot(RelationGetDescr(heapRelation),
+									TTS_TYPE_HEAPTUPLE);
 
 	/* Arrange for econtext's scan tuple to be the tuple under test */
 	econtext->ecxt_scantuple = slot;
@@ -2900,7 +2908,8 @@ IndexCheckExclusion(Relation heapRelation,
 	 */
 	estate = CreateExecutorState();
 	econtext = GetPerTupleExprContext(estate);
-	slot = MakeSingleTupleTableSlot(RelationGetDescr(heapRelation));
+	slot = MakeSingleTupleTableSlot(RelationGetDescr(heapRelation),
+									TTS_TYPE_HEAPTUPLE);
 
 	/* Arrange for econtext's scan tuple to be the tuple under test */
 	econtext->ecxt_scantuple = slot;
@@ -3218,7 +3227,8 @@ validate_index_heapscan(Relation heapRelation,
 	 */
 	estate = CreateExecutorState();
 	econtext = GetPerTupleExprContext(estate);
-	slot = MakeSingleTupleTableSlot(RelationGetDescr(heapRelation));
+	slot = MakeSingleTupleTableSlot(RelationGetDescr(heapRelation),
+									TTS_TYPE_HEAPTUPLE);
 
 	/* Arrange for econtext's scan tuple to be the tuple under test */
 	econtext->ecxt_scantuple = slot;
diff --git a/src/backend/catalog/indexing.c b/src/backend/catalog/indexing.c
index a84b7da114a..748f0a98cdf 100644
--- a/src/backend/catalog/indexing.c
+++ b/src/backend/catalog/indexing.c
@@ -95,7 +95,8 @@ CatalogIndexInsert(CatalogIndexState indstate, HeapTuple heapTuple)
 	heapRelation = indstate->ri_RelationDesc;
 
 	/* Need a slot to hold the tuple being examined */
-	slot = MakeSingleTupleTableSlot(RelationGetDescr(heapRelation));
+	slot = MakeSingleTupleTableSlot(RelationGetDescr(heapRelation),
+									TTS_TYPE_HEAPTUPLE);
 	ExecStoreTuple(heapTuple, slot, InvalidBuffer, false);
 
 	/*
diff --git a/src/backend/catalog/partition.c b/src/backend/catalog/partition.c
index 31c80c7f1ad..be31dcc57db 100644
--- a/src/backend/catalog/partition.c
+++ b/src/backend/catalog/partition.c
@@ -1338,7 +1338,7 @@ check_default_allows_bound(Relation parent, Relation default_rel,
 		econtext = GetPerTupleExprContext(estate);
 		snapshot = RegisterSnapshot(GetLatestSnapshot());
 		scan = heap_beginscan(part_rel, snapshot, 0, NULL);
-		tupslot = MakeSingleTupleTableSlot(tupdesc);
+		tupslot = MakeSingleTupleTableSlot(tupdesc, TTS_TYPE_HEAPTUPLE);
 
 		/*
 		 * Switch to per-tuple memory context and reset it for each tuple
diff --git a/src/backend/commands/analyze.c b/src/backend/commands/analyze.c
index 5f21fcb5f40..d49068f0966 100644
--- a/src/backend/commands/analyze.c
+++ b/src/backend/commands/analyze.c
@@ -783,7 +783,8 @@ compute_index_stats(Relation onerel, double totalrows,
 		estate = CreateExecutorState();
 		econtext = GetPerTupleExprContext(estate);
 		/* Need a slot to hold the current heap tuple, too */
-		slot = MakeSingleTupleTableSlot(RelationGetDescr(onerel));
+		slot = MakeSingleTupleTableSlot(RelationGetDescr(onerel),
+										TTS_TYPE_HEAPTUPLE);
 
 		/* Arrange for econtext's scan tuple to be the tuple under test */
 		econtext->ecxt_scantuple = slot;
diff --git a/src/backend/commands/constraint.c b/src/backend/commands/constraint.c
index 90f19ad3dd9..2d77f475319 100644
--- a/src/backend/commands/constraint.c
+++ b/src/backend/commands/constraint.c
@@ -122,7 +122,8 @@ unique_key_recheck(PG_FUNCTION_ARGS)
 	/*
 	 * The heap tuple must be put into a slot for FormIndexDatum.
 	 */
-	slot = MakeSingleTupleTableSlot(RelationGetDescr(trigdata->tg_relation));
+	slot = MakeSingleTupleTableSlot(RelationGetDescr(trigdata->tg_relation),
+									TTS_TYPE_HEAPTUPLE);
 
 	ExecStoreTuple(new_row, slot, InvalidBuffer, false);
 
diff --git a/src/backend/commands/copy.c b/src/backend/commands/copy.c
index d5883c98d15..27aae408ac6 100644
--- a/src/backend/commands/copy.c
+++ b/src/backend/commands/copy.c
@@ -2444,9 +2444,11 @@ CopyFrom(CopyState cstate)
 	estate->es_range_table = cstate->range_table;
 
 	/* Set up a tuple slot too */
-	myslot = ExecInitExtraTupleSlot(estate, tupDesc);
+	myslot = ExecInitExtraTupleSlot(estate, tupDesc,
+									TTS_TYPE_HEAPTUPLE);
 	/* Triggers might need a slot as well */
-	estate->es_trig_tuple_slot = ExecInitExtraTupleSlot(estate, NULL);
+	estate->es_trig_tuple_slot = ExecInitExtraTupleSlot(estate, NULL,
+														TTS_TYPE_HEAPTUPLE);
 
 	/* Prepare to catch AFTER triggers. */
 	AfterTriggerBeginQuery();
@@ -4747,7 +4749,7 @@ copy_dest_receive(TupleTableSlot *slot, DestReceiver *self)
 	slot_getallattrs(slot);
 
 	/* And send the data */
-	CopyOneRowTo(cstate, InvalidOid, slot->tts_values, slot->tts_isnull);
+	CopyOneRowTo(cstate, InvalidOid, slot->values, slot->nulls);
 	myState->processed++;
 
 	return true;
diff --git a/src/backend/commands/createas.c b/src/backend/commands/createas.c
index 3d82edbf581..fbb84382280 100644
--- a/src/backend/commands/createas.c
+++ b/src/backend/commands/createas.c
@@ -588,7 +588,7 @@ intorel_receive(TupleTableSlot *slot, DestReceiver *self)
 	 * get the heap tuple out of the tuple table slot, making sure we have a
 	 * writable copy
 	 */
-	tuple = ExecMaterializeSlot(slot);
+	tuple = ExecCopySlotTuple(slot);
 
 	/*
 	 * force assignment of new OID (see comments in ExecInsert)
diff --git a/src/backend/commands/subscriptioncmds.c b/src/backend/commands/subscriptioncmds.c
index 9de59693022..2c2cc4f33d5 100644
--- a/src/backend/commands/subscriptioncmds.c
+++ b/src/backend/commands/subscriptioncmds.c
@@ -1148,7 +1148,7 @@ fetch_table_list(WalReceiverConn *wrconn, List *publications)
 						res->err)));
 
 	/* Process tables. */
-	slot = MakeSingleTupleTableSlot(res->tupledesc);
+	slot = MakeSingleTupleTableSlot(res->tupledesc, TTS_TYPE_MINIMALTUPLE);
 	while (tuplestore_gettupleslot(res->tuplestore, true, false, slot))
 	{
 		char	   *nspname;
diff --git a/src/backend/commands/tablecmds.c b/src/backend/commands/tablecmds.c
index 89454d8e80f..6cca6a4b65e 100644
--- a/src/backend/commands/tablecmds.c
+++ b/src/backend/commands/tablecmds.c
@@ -4588,8 +4588,8 @@ ATRewriteTable(AlteredTableInfo *tab, Oid OIDNewHeap, LOCKMODE lockmode)
 		 * tuples are the same, the tupDescs might not be (consider ADD COLUMN
 		 * without a default).
 		 */
-		oldslot = MakeSingleTupleTableSlot(oldTupDesc);
-		newslot = MakeSingleTupleTableSlot(newTupDesc);
+		oldslot = MakeSingleTupleTableSlot(oldTupDesc, TTS_TYPE_HEAPTUPLE);
+		newslot = MakeSingleTupleTableSlot(newTupDesc, TTS_TYPE_HEAPTUPLE);
 
 		/* Preallocate values/isnull arrays */
 		i = Max(newTupDesc->natts, oldTupDesc->natts);
@@ -8280,7 +8280,7 @@ validateCheckConstraint(Relation rel, HeapTuple constrtup)
 
 	econtext = GetPerTupleExprContext(estate);
 	tupdesc = RelationGetDescr(rel);
-	slot = MakeSingleTupleTableSlot(tupdesc);
+	slot = MakeSingleTupleTableSlot(tupdesc, TTS_TYPE_HEAPTUPLE);
 	econtext->ecxt_scantuple = slot;
 
 	snapshot = RegisterSnapshot(GetLatestSnapshot());
diff --git a/src/backend/commands/trigger.c b/src/backend/commands/trigger.c
index fffc0095a79..aeeae171115 100644
--- a/src/backend/commands/trigger.c
+++ b/src/backend/commands/trigger.c
@@ -2342,7 +2342,7 @@ ExecBRInsertTriggers(EState *estate, ResultRelInfo *relinfo,
 		TupleTableSlot *newslot = estate->es_trig_tuple_slot;
 		TupleDesc	tupdesc = RelationGetDescr(relinfo->ri_RelationDesc);
 
-		if (newslot->tts_tupleDescriptor != tupdesc)
+		if (newslot->tupleDescriptor != tupdesc)
 			ExecSetSlotDescriptor(newslot, tupdesc);
 		ExecStoreTuple(newtuple, newslot, InvalidBuffer, false);
 		slot = newslot;
@@ -2423,7 +2423,7 @@ ExecIRInsertTriggers(EState *estate, ResultRelInfo *relinfo,
 		TupleTableSlot *newslot = estate->es_trig_tuple_slot;
 		TupleDesc	tupdesc = RelationGetDescr(relinfo->ri_RelationDesc);
 
-		if (newslot->tts_tupleDescriptor != tupdesc)
+		if (newslot->tupleDescriptor != tupdesc)
 			ExecSetSlotDescriptor(newslot, tupdesc);
 		ExecStoreTuple(newtuple, newslot, InvalidBuffer, false);
 		slot = newslot;
@@ -2829,7 +2829,7 @@ ExecBRUpdateTriggers(EState *estate, EPQState *epqstate,
 		TupleTableSlot *newslot = estate->es_trig_tuple_slot;
 		TupleDesc	tupdesc = RelationGetDescr(relinfo->ri_RelationDesc);
 
-		if (newslot->tts_tupleDescriptor != tupdesc)
+		if (newslot->tupleDescriptor != tupdesc)
 			ExecSetSlotDescriptor(newslot, tupdesc);
 		ExecStoreTuple(newtuple, newslot, InvalidBuffer, false);
 		slot = newslot;
@@ -2937,7 +2937,7 @@ ExecIRUpdateTriggers(EState *estate, ResultRelInfo *relinfo,
 		TupleTableSlot *newslot = estate->es_trig_tuple_slot;
 		TupleDesc	tupdesc = RelationGetDescr(relinfo->ri_RelationDesc);
 
-		if (newslot->tts_tupleDescriptor != tupdesc)
+		if (newslot->tupleDescriptor != tupdesc)
 			ExecSetSlotDescriptor(newslot, tupdesc);
 		ExecStoreTuple(newtuple, newslot, InvalidBuffer, false);
 		slot = newslot;
@@ -3252,11 +3252,11 @@ TriggerEnabled(EState *estate, ResultRelInfo *relinfo,
 			{
 				oldContext = MemoryContextSwitchTo(estate->es_query_cxt);
 				estate->es_trig_oldtup_slot =
-					ExecInitExtraTupleSlot(estate, NULL);
+					ExecInitExtraTupleSlot(estate, NULL, TTS_TYPE_HEAPTUPLE);
 				MemoryContextSwitchTo(oldContext);
 			}
 			oldslot = estate->es_trig_oldtup_slot;
-			if (oldslot->tts_tupleDescriptor != tupdesc)
+			if (oldslot->tupleDescriptor != tupdesc)
 				ExecSetSlotDescriptor(oldslot, tupdesc);
 			ExecStoreTuple(oldtup, oldslot, InvalidBuffer, false);
 		}
@@ -3266,11 +3266,11 @@ TriggerEnabled(EState *estate, ResultRelInfo *relinfo,
 			{
 				oldContext = MemoryContextSwitchTo(estate->es_query_cxt);
 				estate->es_trig_newtup_slot =
-					ExecInitExtraTupleSlot(estate, NULL);
+					ExecInitExtraTupleSlot(estate, NULL, TTS_TYPE_HEAPTUPLE);
 				MemoryContextSwitchTo(oldContext);
 			}
 			newslot = estate->es_trig_newtup_slot;
-			if (newslot->tts_tupleDescriptor != tupdesc)
+			if (newslot->tupleDescriptor != tupdesc)
 				ExecSetSlotDescriptor(newslot, tupdesc);
 			ExecStoreTuple(newtup, newslot, InvalidBuffer, false);
 		}
@@ -4273,8 +4273,10 @@ afterTriggerInvokeEvents(AfterTriggerEventList *events,
 							ExecDropSingleTupleTableSlot(slot1);
 							ExecDropSingleTupleTableSlot(slot2);
 						}
-						slot1 = MakeSingleTupleTableSlot(rel->rd_att);
-						slot2 = MakeSingleTupleTableSlot(rel->rd_att);
+						slot1 = MakeSingleTupleTableSlot(rel->rd_att,
+														 TTS_TYPE_HEAPTUPLE);
+						slot2 = MakeSingleTupleTableSlot(rel->rd_att,
+														 TTS_TYPE_HEAPTUPLE);
 					}
 					if (trigdesc == NULL)	/* should not happen */
 						elog(ERROR, "relation %u has no triggers",
diff --git a/src/backend/executor/execCurrent.c b/src/backend/executor/execCurrent.c
index ce7d4ac592a..2574639ecef 100644
--- a/src/backend/executor/execCurrent.c
+++ b/src/backend/executor/execCurrent.c
@@ -13,6 +13,7 @@
 #include "postgres.h"
 
 #include "access/sysattr.h"
+#include "access/htup_details.h"
 #include "catalog/pg_type.h"
 #include "executor/executor.h"
 #include "utils/builtins.h"
@@ -183,16 +184,22 @@ execCurrentOf(CurrentOfExpr *cexpr,
 		if (TupIsNull(scanstate->ss_ScanTupleSlot))
 			return false;
 
+#if 0
 		/* Use slot_getattr to catch any possible mistakes */
 		tuple_tableoid =
-			DatumGetObjectId(slot_getattr(scanstate->ss_ScanTupleSlot,
-										  TableOidAttributeNumber,
-										  &lisnull));
+			DatumGetObjectId(heap_getsysattr(scanstate->ss_ScanTupleSlot->tts_tuple,
+											 TableOidAttributeNumber,
+											 scanstate->ss_ScanTupleSlot->tts_tupleDescriptor,
+											 &lisnull));
 		Assert(!lisnull);
 		tuple_tid = (ItemPointer)
-			DatumGetPointer(slot_getattr(scanstate->ss_ScanTupleSlot,
-										 SelfItemPointerAttributeNumber,
-										 &lisnull));
+			DatumGetPointer(heap_getsysattr(scanstate->ss_ScanTupleSlot->tts_tuple,
+											 SelfItemPointerAttributeNumber,
+											 scanstate->ss_ScanTupleSlot->tts_tupleDescriptor,
+											 &lisnull));
+#else
+		elog(ERROR, "not yet");
+#endif
 		Assert(!lisnull);
 
 		Assert(tuple_tableoid == table_oid);
diff --git a/src/backend/executor/execExpr.c b/src/backend/executor/execExpr.c
index db5fcafbfe4..c6e478c3650 100644
--- a/src/backend/executor/execExpr.c
+++ b/src/backend/executor/execExpr.c
@@ -2415,7 +2415,8 @@ ExecInitWholeRowVar(ExprEvalStep *scratch, Var *variable, ExprState *state)
 				scratch->d.wholerow.junkFilter =
 					ExecInitJunkFilter(subplan->plan->targetlist,
 									   ExecGetResultType(subplan)->tdhasoid,
-									   ExecInitExtraTupleSlot(parent->state, NULL));
+									   ExecInitExtraTupleSlot(parent->state, NULL,
+															  TTS_TYPE_VIRTUAL));
 			}
 		}
 	}
@@ -2994,8 +2995,8 @@ ExecBuildAggTrans(AggState *aggstate, AggStatePerPhase phase,
 			/*
 			 * DISTINCT and/or ORDER BY case, with multiple columns sorted on.
 			 */
-			Datum	   *values = pertrans->sortslot->tts_values;
-			bool	   *nulls = pertrans->sortslot->tts_isnull;
+			Datum	   *values = pertrans->sortslot->values;
+			bool	   *nulls = pertrans->sortslot->nulls;
 
 			strictnulls = nulls;
 
